using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ArincAPI;
using ArincAPI.DataTypes;
using System.Runtime.InteropServices;
using System.Threading;

namespace ArincCsApp
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void Form1_Load(object sender, EventArgs e)
      {
         this.CenterToScreen();

         // setup channel and device num combo boxes
         cbDeviceNum.SelectedIndex = 0;
         cbTxChannel.SelectedIndex = 0;
         cbTxBusSpeed.SelectedIndex = 0;
         cbRxChannel.SelectedIndex = 0;
         cbRxBusSpeed.SelectedIndex = 0;
         cbRxParity.SelectedIndex = 1;
         cbTxParity.SelectedIndex = 2;

         cbDeviceNum.Enabled = true;
         btnStartStop.Enabled = false;
         groupBox1.Enabled = false;
         groupBox2.Enabled = false;
         label2.Enabled = false;
         label9.Enabled = false;
         cbTxChannel.Enabled = false;
         cbTxBusSpeed.Enabled = false;
         cbRxChannel.Enabled = false;
         cbRxBusSpeed.Enabled = false;
         cbRxParity.Enabled = false;
         cbTxParity.Enabled = false;
         numTransmitMessage.Enabled = false;
         numTransmitMsgRate.Enabled = false;
         label10.Enabled = false;
         label11.Enabled = false;
         ArincFunctions.mainForm = this;
      }

      private void btOpenClose_Click(object sender, EventArgs e)
      {
         Int16 device = (Int16)cbDeviceNum.SelectedIndex;
         short status;

         if (btOpenClose.Text == "Open Session")
         {
            tbFwVersion.Clear();
            tbOutput.Clear();
            btnStartStop.Enabled = false;
            btnStartStop.Text = "Go";
            groupBox1.Enabled = false;
            groupBox2.Enabled = false;
            label9.Enabled = false;
            label2.Enabled = false;
            cbTxChannel.Enabled = false;
            cbTxBusSpeed.Enabled = false;
            cbRxChannel.Enabled = false;
            cbRxBusSpeed.Enabled = false;
            cbRxParity.Enabled = false;
            cbTxParity.Enabled = false;
            numTransmitMessage.Enabled = false;
            numTransmitMsgRate.Enabled = false;
            label10.Enabled = false;
            label11.Enabled = false;

            status = ArincFunctions.Init(device);
            if (status == ArincAPI.Constants.ARS_NORMAL)
            {
               btOpenClose.Text = "Close Session";
               btnStartStop.Enabled = true;
               groupBox1.Enabled = true;
               groupBox2.Enabled = true;
               label9.Enabled = true;
               label2.Enabled = true;
               cbTxChannel.Enabled = true;
               cbTxBusSpeed.Enabled = true;
               cbRxChannel.Enabled = true;
               cbRxBusSpeed.Enabled = true;
               cbRxParity.Enabled = true;
               cbTxParity.Enabled = true;
               numTransmitMessage.Enabled = true;
               numTransmitMsgRate.Enabled = true;
               label10.Enabled = true;
               label11.Enabled = true;
            }
            else
            {
               tbFwVersion.Clear();
            }
         }
         else
         {
            btOpenClose.Text = "Open Session";
            btnStartStop.Text = "Start";
            cbDeviceNum.Enabled = true;
            btnStartStop.Enabled = false;
            groupBox1.Enabled = false;
            groupBox2.Enabled = false;
            label2.Enabled = false;
            label9.Enabled = false;
            cbTxChannel.Enabled = false;
            cbTxBusSpeed.Enabled = false;
            cbRxChannel.Enabled = false;
            cbRxBusSpeed.Enabled = false;
            cbRxParity.Enabled = false;
            cbTxParity.Enabled = false;
            numTransmitMessage.Enabled = false;
            numTransmitMsgRate.Enabled = false;
            label10.Enabled = false;
            label11.Enabled = false;
            tbFwVersion.Clear();
            status = ArincFunctions.Close(device);
         }
      }

      private void btnStartStop_Click(object sender, EventArgs e)
      {
         Int16 device = (Int16)cbDeviceNum.SelectedIndex;
         short status;

         if (btnStartStop.Text == "Go")
         {
            // start up the test

            tbOutput.Clear();
            btnStartStop.Text = "Stop";
            groupBox1.Enabled = false;
            groupBox2.Enabled = false;
            label2.Enabled = false;
            cbDeviceNum.Enabled = false;
            cbTxChannel.Enabled = false;
            cbTxBusSpeed.Enabled = false;
            cbRxChannel.Enabled = false;
            cbRxBusSpeed.Enabled = false;
            cbRxParity.Enabled = false;
            cbTxParity.Enabled = false;
            numTransmitMessage.Enabled = false;
            numTransmitMsgRate.Enabled = false;
            label10.Enabled = false;
            label11.Enabled = false;

             status = ArincFunctions.Activate(device);
         }
         else
         {
            // shut everything down
            btnStartStop.Text = "Go";
            status = ArincFunctions.Terminate(device);

            groupBox1.Enabled = true;
            groupBox2.Enabled = true;
            label2.Enabled = true;
            cbDeviceNum.Enabled = true;
            cbTxChannel.Enabled = true;
            cbTxBusSpeed.Enabled = true;
            cbRxChannel.Enabled = true;
            cbRxBusSpeed.Enabled = true;
            cbRxParity.Enabled = true;
            cbTxParity.Enabled = true;
            numTransmitMessage.Enabled = true;
            numTransmitMsgRate.Enabled = true;
            label10.Enabled = true;
            label11.Enabled = true;
         }
      }

      private void label10_Click(object sender, EventArgs e)
      {

      }

      private void numTransmitMessage_ValueChanged(object sender, EventArgs e)
      {

      }
   }
}



