using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace ArincAPI
{
   public class API
   {
      private const String dllPath = @"cdev_api.DLL";

      [DllImport(dllPath, EntryPoint = "ar_assign_scheduler_start_offsets")]
      public static extern Int32 Assign_Scheduler_Start_Offsets
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_bypass_wrap_test")]
      public static extern Int16 Bypass_Wrap_Test
      (
         Int16 board,
         Int16 bypass
      );
      [DllImport(dllPath, EntryPoint = "ar_close")]
      public static extern Int16 Close_Session
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_clr_rx_count")]
      public static extern Int32 Clear_Rx_Count
      (
         Int16 board,
         Int16 channel
      );
      [DllImport(dllPath, EntryPoint = "ar_define_msg")]
      public static extern Int32 Define_Periodic_Message
      (
         Int16 board,
         Int16 channel,
         Int16 rate,
         Int16 offset,
         Int32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_define_msg_block")]
      public static extern Int16 Define_Msg_Block
      (
         Int32 numberOfEntries,
         [In, Out] DataTypes.AR_SCHEDULED_MSG_ENTRY_TYPE messageEntry
      );
      [DllImport(dllPath, EntryPoint = "ar_enh_label_filter")]
      public static extern Int32 Enh_Label_Filter
      (
         Int16 board,
         Int16 channel,
         UInt16 label,
         UInt16 sdi,
         UInt16 essm,
         Int16 action
      );
      [DllImport(dllPath, EntryPoint = "ar_execute_bit")]
      public static extern Int16 Execute_Bit
      (
         Int16 board,
         Int16 testType
      );
      [DllImport(dllPath, EntryPoint = "ar_getblock")]
      public static extern Int32 Get_Msg_Block
      (
         UInt32 board,
         UInt32 channel,
         Int32 maxMessages,
         Int32 offset,
         ref Int32 actualCount,
         ref Int32 data,
         ref Int32 timeTags
      );
      [DllImport(dllPath, EntryPoint = "ar_getblock_t")]
      public static extern Int32 Get_Msg_Block_T
      (
         UInt32 board,
         UInt32 channel,
         Int32 maxMessages,
         ref Int32 actualCount,
         ref UInt32 msgChan,
         ref Int32 data,
         ref Int32 timeTagMsw,
         ref Int32 timeTagLsw
      );
      [DllImport(dllPath, EntryPoint = "ar_get_boardname")]
      public static extern String Get_Board_Name
      (
         UInt32 board,
         String boardName
      );
      [DllImport(dllPath, EntryPoint = "ar_get_boardtype")]
      public static extern Int16 Get_Board_Type
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_get_config")]
      public static extern Int32 Get_Config
      (
         Int16 board,
         Int16 item
      );
      [DllImport(dllPath, EntryPoint = "ar_get_data")]
      public static extern Int16 Get_Data
      (
         Int16 board,
         ref Int16 channel,
         ref UInt32 data,
         ref UInt32 timeTagLo,
         ref UInt32 timeTagHi
      );
      [DllImport(dllPath, EntryPoint = "ar_get_data_xt")]
      public static extern Int16 Get_Data_XT
      (
         Int16 board,
         ref Int16 channel,
         ref UInt32 data,
         [In, Out] DataTypes.AR_TIMETAG_TYPE timeTagRef
      );
      [DllImport(dllPath, EntryPoint = "ar_get_device_config")]
      public static extern Int16 Get_Device_Config
      (
         Int16 board,
         Int16 channel,
         Int16 item,
         ref Int16 value
      );
      [DllImport(dllPath, EntryPoint = "ar_get_error")]
      public static extern String Get_Error
      (
         Int16 error_num
      );
      [DllImport(dllPath, EntryPoint = "ar_get_429_message ")]
      public static extern Int16 Get_429_Message
      (
         Int16 board,
         Int16 channel,
         Int16 waitState,
         ref UInt32 data,
         ref UInt32 timeTag
      );
      [DllImport(dllPath, EntryPoint = "ar_get_573_config")]
      public static extern Int16 Get_573_Config
      (
         Int16 board,
         Int16 item,
         ref Int32 value
      );
      [DllImport(dllPath, EntryPoint = "ar_get_573_frame")]
      public static extern Int16 Get_573_Frame
      (
         Int16 board,
         ref UInt32 numberWords,
         ref UInt16 arincData
      );
      [DllImport(dllPath, EntryPoint = "ar_getfilter")]
      public static extern Int32 Get_Filter_Table
      (
         UInt32 board,
         UInt32 channel,
         String filterTable
      );
      [DllImport(dllPath, EntryPoint = "ar_get_label_filter")]
      public static extern Int16 Get_Label_Filter
      (
         Int16 board,
         UInt16 label
      );
      [DllImport(dllPath, EntryPoint = "ar_get_latest")]
      public static extern void Get_Latest
      (
         Int16 board,
         Int16 channel,
         UInt16 label,
         ref UInt32 data,
         String seq_num
      );
      [DllImport(dllPath, EntryPoint = "ar_get_latest_t")]
      public static extern Int32 Get_Latest_T
      (
         Int16 board,
         Int16 channel,
         UInt16 label,
         ref UInt32 data,
         ref UInt64 timeTag
      );
      [DllImport(dllPath, EntryPoint = "ar_getnext")]
      public static extern Int16 Get_Next
      (
         Int16 board,
         Int16 channel,
         ref UInt32 destination
      );
      [DllImport(dllPath, EntryPoint = "ar_getnextt")]
      public static extern Int16 Get_Next_T
      (
         Int16 board,
         Int16 channel,
         ref UInt32 destination,
         ref UInt32 timeTag
      );
      [DllImport(dllPath, EntryPoint = "ar_getnext_xt")]
      public static extern Int16 Get_Next_XT
      (
         Int16 board,
         Int16 channel,
         ref UInt32 data,
         [In, Out] DataTypes.AR_TIMETAG_TYPE timeTagRef
      );
      [DllImport(dllPath, EntryPoint = "ar_get_snap_data")]
      public static extern Int32 Get_Snap_Data
      (
         Int16 board,
         Int16 channel,
         UInt16 label,
         UInt16 sdi,
         ref Int32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_get_rx_channel_status")]
      public static extern UInt32 Get_RX_Channel_Status
      (
         Int16 board,
         Int16 channel,
         ref Int32 channelStatus,
         ref Int32 messageCount
      );
      [DllImport(dllPath, EntryPoint = "ar_get_rx_count")]
      public static extern UInt32 Get_RX_Count
      (
         Int16 board,
         Int16 channel
      );
      [DllImport(dllPath, EntryPoint = "ar_get_status")]
      public static extern Int16 Get_RX_Status
      (
         Int16 board,
         ref Int16 state
      );
      [DllImport(dllPath, EntryPoint = "ar_get_storage_mode")]
      public static extern Int16 Get_RX_Storage_Mode
      (
         Int16 board,
         ref Int16 mode
      );
      [DllImport(dllPath, EntryPoint = "ar_get_time")]
      public static extern Int16 Get_Time
      (
         Int16 board,
         Int16 format,
         [In, Out] DataTypes.AR_TIMETAG_TYPE boardTime
      );
      [DllImport(dllPath, EntryPoint = "ar_get_transmitter_mode")]
      public static extern Int16 Get_Transmitter_Mode
      (
         Int16 board,
         ref Int16 mode
      );
      [DllImport(dllPath, EntryPoint = "ar_getword")]
      public static extern Int16 Get_Word
      (
         Int16 board,
         Int16 channel,
         ref UInt32 destination
      );
      [DllImport(dllPath, EntryPoint = "ar_getwordt")]
      public static extern Int16 Get_Word_T
      (
         Int16 board,
         Int16 channel,
         ref UInt32 destination,
         ref UInt32 timeTag
      );
      [DllImport(dllPath, EntryPoint = "ar_getword_xt")]
      public static extern Int16 Get_Word_XT
      (
         Int16 board,
         Int16 channel,
         ref UInt32 data,
         [In, Out] DataTypes.AR_TIMETAG_TYPE timeTagRef
      );
      [DllImport(dllPath, EntryPoint = "ar_go")]
      public static extern Int16 Go
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_hw_interrupt_buffer_read")]
      public static extern Int32 Interrupt_Buffer_Read
      (
         Int32 board,
         ref UInt32 numberOfWords,
         ref UInt32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_interrupt_queue_read")]
      public static extern Int32 Interrupt_Queue_Read
      (
         Int32 board,
         ref UInt32 numberOfWords,
         ref UInt32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_label_filter")]
      public static extern Int16 Label_Filter
      (
         Int16 board,
         Int16 channel,
         UInt16 label,
         Int16 action
      );
      [DllImport(dllPath, EntryPoint = "ar_modify_msg")]
      public static extern Int16 Modify_Msg
      (
         Int16 board,
         Int16 channel,
         Int16 msgNumber,
         Int16 rate,
         Int32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_modify_msg_block")]
      public static extern Int16 Modify_Msg_Block
      (
         Int32 numberOfEntries,
         [In, Out] DataTypes.AR_SCHEDULED_MSG_ENTRY_TYPE messageEntry
      );
      [DllImport(dllPath, EntryPoint = "ar_num_rchans")]
      public static extern Int16 Num_RX_Chans
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_num_xchans")]
      public static extern Int16 Num_TX_Chans
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_open")]
      public static extern Int16 Open_Session
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_putblock")]
      public static extern Int32 Put_Block
      (
         UInt32 board,
         UInt32 channel,
         Int32 maxMessages,
         Int32 offset,
         ref Int32 data,
         ref Int32 actualCount
      );
      [DllImport(dllPath, EntryPoint = "ar_putblock_multi_chan")]
      public static extern Int32 Put_Block_Multi_Chan
      (
         UInt32 board,
         Int32 maxMessages,
         ref UInt32 channels,
         ref Int32 data,
         ref Int32 actualCount
      );
      [DllImport(dllPath, EntryPoint = "ar_putfilter")]
      public static extern Int32 Put_Filter_Table
      (
         UInt32 board,
         UInt32 channel,
         String filterTable
      );
      [DllImport(dllPath, EntryPoint = "ar_put_429_message")]
      public static extern Int16 Put_429_Message
      (
         Int16 board,
         Int16 channel,
         Int32 data
      );
      [DllImport(dllPath, EntryPoint = "ar_put_573_frame")]
      public static extern Int16 Put_573_Frame
      (
         Int16 board,
         UInt32 numberWords,
         ref UInt32 transmitCount,
         ref UInt16 arincData
      );
      [DllImport(dllPath, EntryPoint = "ar_putword")]
      public static extern Int16 Put_Word
      (
         Int16 board,
         Int16 channel,
         Int32 arincdata
      );
      [DllImport(dllPath, EntryPoint = "ar_query_device")]
      public static extern Int16 Query_Device
      (
          Int16 board,
          ref Int16 boardType
      );
      [DllImport(dllPath, EntryPoint = "ar_read_scheduled_msg_block")]
      public static extern Int16 Read_Scheduled_Msg_Block
      (
         Int16 board,
         Int32 startingEntry,
         Int32 numberOfEntries,
         [In, Out] DataTypes.AR_SCHEDULED_MSG_ENTRY_TYPE messageEntry
      );
      [DllImport(dllPath, EntryPoint = "ar_read_message_schedule_table_entry")]
      public static extern Int16 Read_Message_Schedule_Table_Entry
      (
         Int16 board,
         UInt32 messageIndex,
         ref UInt32 msgSchedTableEntry
      );
      [DllImport(dllPath, EntryPoint = "ar_reset")]
      public static extern Int16 Reset_Device
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_reset_timercnt")]
      public static extern void Reset_Timer_Count
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_set_config")]
      public static extern Int16 Set_Config
      (
         Int16 board,
         Int16 item,
         UInt32 value
      );
      [DllImport(dllPath, EntryPoint = "ar_set_device_config")]
      public static extern Int16 Set_Device_Config
      (
         Int16 board,
         Int16 channel,
         Int16 item,
         Int16 value
      );
      [DllImport(dllPath, EntryPoint = "ar_set_573_config")]
      public static extern Int16 Set_573_Config
      (
         Int16 board,
         Int16 item,
         Int32 value
      );
      [DllImport(dllPath, EntryPoint = "ar_set_multithread_protect")]
      public static extern Int16 Set_Multi_Thread_Protect
      (
         Int16 board,
         Int16 state
      );
      [DllImport(dllPath, EntryPoint = "ar_set_isr_function")]
      public static extern Int32 Set_ISR_Function
      (
         Int32 deviceIndex,
         IntPtr function
      );
      [DllImport(dllPath, EntryPoint = "ar_set_preload_config")]
      public static extern Int16 Set_Preload_Config
      (
         Int16 board,
         Int16 item,
         UInt32 value
      );
      [DllImport(dllPath, EntryPoint = "ar_set_raw_mode")]
      public static extern Int16 Set_Raw_Mode
      (
         Int16 board,
         Int16 direction,
         Int16 channel,
         Int16 control
      );
      [DllImport(dllPath, EntryPoint = "ar_set_storage_mode")]
      public static extern Int16 Set_Storage_Mode
      (
         Int16 board,
         Int16 mode
      );
      [DllImport(dllPath, EntryPoint = "ar_set_time")]
      public static extern Int16 Set_Time
      (
         Int16 board,
         [In, Out] DataTypes.AR_TIMETAG_TYPE setTimeTag
      );
      [DllImport(dllPath, EntryPoint = "ar_set_timerrate")]
      public static extern void Set_Timer_Rate
      (
         Int16 board,
         Int16 rate
      );
      [DllImport(dllPath, EntryPoint = "ar_set_transmitter_mode")]
      public static extern Int16 Set_Transmitter_Mode
      (
         Int16 board,
         Int16 mode
      );
      [DllImport(dllPath, EntryPoint = "ar_stop")]
      public static extern Int16 Stop
      (
         Int16 board
      );
      [DllImport(dllPath, EntryPoint = "ar_update_message_block")]
      public static extern Int32 Update_Message_Block
      (
         Int16 board,
         UInt32 numberOfMsgs,
         UInt32 msgIndex,
         ref UInt32 msgValues
      );
      [DllImport(dllPath, EntryPoint = "ar_xmit_sync")]
      public static extern Int16 Transmit_Sync
      (
         Int16 board,
         Int16 channel
      );
      [DllImport(dllPath, EntryPoint = "ar_sleep")]
      public static extern void Sleep
      (
         UInt32 sleep_ms
      );
   }
}
