using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace ArincAPI
{
   public class Constants
   {
      public const Int16 ARS_FAILURE = -1;
      public const Int16 ARS_NODATA = 0;
      public const Int16 ARS_NORMAL = 1;
      public const Int16 ARS_GOTDATA = 4;
      public const Int16 ARS_BAD_MESSAGE = 5;
      public const Int16 ARS_RX_BUFFER_OVERRUN = 6;
      public const Int16 ARS_SYNCOVERRUN = 6;
      public const Int16 BTD_ERR_NOWINRT = 50;
      public const Int16 BTD_ERR_BADREGISTER = 51;
      public const Int16 BTD_ERR_BADOPEN = 52;
      public const Int16 BTD_ERR_NOSUPPORT = 53;
      public const Int16 ARS_INVHARCMD = 1002;
      public const Int16 ARS_INVHARVAL = 1003;
      public const Int16 ARS_XMITOVRFLO = 1004;
      public const Int16 ARS_INVBOARD = 1005;
      public const Int16 ARS_NOSYNC = 1006;
      public const Int16 ARS_BADLOAD = 1007;
      public const Int16 ARS_BRDNOTLOAD = 1008;
      public const Int16 ARS_SYNCTIMEOUT = 1009;
      public const Int16 ARS_BADINIT = 1011;
      public const Int16 ARS_MEMADERR = 1012;
      public const Int16 ARS_MEMWRERR = 1013;
      public const Int16 ARS_INVSTRING = 1014;
      public const Int16 ARS_INVEQID = 1015;
      public const Int16 ARS_CHECKSUM = 1016;
      public const Int16 ARS_NORESPONSE = 1017;
      public const Int16 ARS_UNSUPTYPE = 1018;
      public const Int16 ARS_INVARG = 1019;
      public const Int16 ARS_INVLABEL = 1020;
      public const Int16 ARS_DRIVERFAIL = 1021;
      public const Int16 ARS_WINRTFAIL = 1022;
      public const Int16 ARS_CHAN_TIMEOUT = 1023;
      public const Int16 ARS_NO_HW_SUPRT = 1024;
      public const Int16 ARS_BAD_DAC_VAL = 1025;
      public const Int16 ARS_BAD_FPGA = 1026;
      public const Int16 ARS_BAD_STATIC = 1027;
      public const Int16 ARS_LAST_ERROR = 1028;
      public const Int16 ARS_HW_CONSISTENCY = 1029;
      public const Int16 ARS_HW_DETECT = 1030;
      public const Int16 ARS_WRAP_DATA_FAIL = 1031;
      public const Int16 ARS_WRAP_RATE_FAIL = 1032;
      public const Int16 ARS_SHORT_DATA_FRAME = 1033;
      public const Int16 ARS_LONG_DATA_FRAME = 1034;
      public const Int16 ARS_WRAP_FLUSH_FAIL = 1035;
      public const Int16 ARS_WRAP_DROP_FAIL = 1036;
      public const Int16 ARS_ERR_SH_MEM_OBJ = 1037;
      public const Int16 ARS_ERR_SH_MEM_MAP = 1038;
      public const Int16 ARS_CONFIG_MUTEX = 1039;
      public const Int16 ARS_NOT_SUPPORTED = 1040;
      public const Int16 ARS_NO_OS_SUPPORT = 1041;
      public const Int16 ARS_NOT_EXCLUSIVE = 1042;
      public const Int16 ARS_NO_INT_SUPPORT = 1043;
      public const Int16 ARS_NO_INT_ENABLED = 1044;
      public const Int16 ARS_ISR_ALREADY_INST = 1045;
      public const Int16 ARS_THREAD_WAITING = 1046;
      public const Int16 ARS_WAIT_FAILED = 1047;
      public const Int16 ARS_SIGNAL_FAILED = 1048;
      public const Int16 ARS_CHANNEL_TYPE = 1049;
      public const Int16 ARS_INT_ISR = 1050;
      public const Int16 ARS_BOARD_MUTEX = 1051;
      public const Int16 ARS_FW_NOT_SUPPORTED = 1052;
      public const Int16 ARS_RX_BIT_CMD_ERROR = 1100;
      public const Int16 ARS_RX_BIT_CH01_ERROR = 1101;
      public const Int16 ARS_RX_BIT_CH32_ERROR = 1132;

      /*------------------------------------------------------------------------
       * Constants returned from ar_get_boardtype
       *------------------------------------------------------------------------*/
      public const Int16 CEI830 = 19;
      public const Int16 CEI430 = 21;
      public const Int16 AMCA30 = 22;
      public const Int16 CEI530 = 26;
      public const Int16 R830RX = 27;
      public const Int16 RARCPCI = 28;
      public const Int16 RAREC = 29;
      public const Int16 RARPCIE = 30;
      public const Int16 CEI430A = 31;
      public const Int16 CEI830X820 = 34;
      public const Int16 RARXMC = 35;
      public const Int16 RCEI830A = 36;
      public const Int16 RP_708 = 37;
      public const Int16 RAR15XT = 119;
      public const Int16 CEI520 = 6;
      public const Int16 CEI620 = 10;
      public const Int16 CEI820 = 11;
      public const Int16 CEI715 = 16;
      public const Int16 PMC708 = 20;

      /*---------------------------------------------------------------------------*
       *  This set of configuration value constants are used with calls to 
       *  the functions ar_set/get_config() or ar_set/get_device_config()
       *---------------------------------------------------------------------------*/
      public const Int16 AR_ODD = 0;
      public const Int16 AR_EVEN = 1;
      public const Int16 AR_RAW = 2;
      public const Int16 AR_WRAP_ON = 0;
      public const Int16 AR_WRAP_OFF = 1;
      public const Int16 AR_ON = 7;                   /* General "Enable" flag */
      public const Int16 AR_OFF = 8;                  /* General "Disable" flag */
      public const Int16 AR_LO = 0;                   /* Discrete & digital I/O states */
      public const Int16 AR_HI = 1;

      public const Int16 ARU_SPEED_HIGH = 0;
      public const Int16 ARU_SPEED_LOW = 1;
      public const Int16 ARU_PARITY_ODD = 0;
      public const Int16 ARU_PARITY_EVEN = 1;
      public const Int16 ARU_PARITY_NONE = 2;

      public const Int16 ARU_RX_BITRATE = 1;
      public const Int16 ARU_TX_BITRATE = 2;
      public const Int16 ARU_RX_PARITY = 3;
      public const Int16 ARU_TX_PARITY = 4;
      public const Int16 ARU_RECV_MODE = 5;
      public const Int16 ARU_TX_BIT_ERROR = 7;
      public const Int16 ARU_TX_GAP_ERROR = 8;
      public const Int16 ARU_RX_DISABLE = 9;
      public const Int16 ARU_TX_DISABLE = 10;
      public const Int16 ARU_CHANNEL_ENABLE = 11;
      public const Int16 ARU_DISCRETE_OUT = 12;
      public const Int16 ARU_DIGITAL_OUT = 13;
      public const Int16 ARU_DISCRETE_IN = 14;
      public const Int16 ARU_DIGITAL_IN = 15;
      public const Int16 ARU_RX_FIFO_ENABLE = 16;
      public const Int16 ARU_TX_FIFO_ENABLE = 17;
      public const Int16 ARU_RX_MERGED_MODE = 18;
      public const Int16 ARU_TX_FIFO_COUNT = 19;
      public const Int16 ARU_FW_VERSION = 20;
      public const Int16 ARU_CONFIGURATION = 21;
      public const Int16 ARU_DIFFERENTIAL_IN = 22;
      public const Int16 ARU_DIFFERENTIAL_OUT = 23;
      public const Int16 ARU_RX_RESET = 24;
      public const Int16 ARU_TX_RESET = 25;
      public const Int16 ARU_IRIG_OUTPUT_ENABLE = 26;
      public const Int16 ARU_IRIG_INPUT_TIME = 27;
      public const Int16 ARU_RX_FIFO_COUNT = 28;
      public const Int16 ARU_HW_INTERRUPT_ENABLE = 29;
      public const Int16 ARU_HW_ENHANCE_CHECK = 30;
      public const Int16 ARU_HW_ENHANCE_UPDATE = 31;
      public const Int16 ARU_RX_MSG_COUNT = 35;
      public const Int16 ARU_TX_MSG_COUNT = 36;
      public const Int16 ARU_INSERT_INT_Q_ENTRY = 37;
      public const Int16 ARU_ACCESS_SNAPSHOT_BUFFER = 38;
      public const Int16 ARU_DEVICE_DISABLE = 39;
      public const Int16 ARU_BYPASS_INIT_WRAP_TEST = 320;
      public const Int16 ARU_MULTITHREAD_PROTECT = 321;
      public const Int16 ARU_DISCRETE_RAW = 322;
      public const Int16 ARU_FAST_SLEW_RATE = 323;
      public const Int16 ARU_RX_TIMETAG_MODE = 440;
      public const Int16 ARU_IRIG_WRAP_ENABLE = 441;
      public const Int16 ARU_IRIG_INPUT_THRESHOLD = 442;
      public const Int16 ARU_IRIG_ADJUST_THRESHOLD = 443;
      public const Int16 ARU_IRIG_QUICK_ADJUSTMENT = 444;
      public const Int16 ARU_IRIG_AVAILABLE = 445;
      public const Int16 ARU_IRIG_SET_BIAS = 446;
      public const Int16 ARU_IRIG_CALIBRATED = 447;
      public const Int16 ARU_CHAN_COUNT_429 = 448;
      public const Int16 ARU_CHAN_COUNT_573 = 449;
      public const Int16 ARU_CHAN_COUNT_DISC = 450;
      public const Int16 ARU_CHAN_COUNT_DIFF = 451;
      public const Int16 ARU_SERIAL_NUMBER = 452;
      public const Int16 ARU_HW_FPGA_TEMPERATURE = 453;
      public const Int16 ARU_HW_1PT0V_PWR_SUPPLY = 454;
      public const Int16 ARU_HW_2PT5V_PWR_SUPPLY = 455;
      public const Int16 ARU_SPECIAL_PROGRAMMABLE_CONFIG = 456;
      public const Int16 ARU_CONFIG_PROGRAMMABLE_CHAN = 457;
      public const Int16 ARU_READ_RAR_XMC_FW_BUILD_NUMBER = 458;
      public const Int16 ARU_RX_MSG_SIZE_24BIT = 459;
      public const Int16 ARU_TX_MSG_SIZE_24BIT = 460;
      public const Int16 ARU_PCI_INTERRUPT_ENABLE = 461;

      /*---------------------------------------------------------------------------*
       *  This set of configuration constants are specifically used with calls to
       *  the function ar_set_config() satisfy the BusTools ARINC interface.
       *---------------------------------------------------------------------------*/
      public const Int16 ARU_XMIT_RATE = 1;         /* AR_HIGH/AR_LOW for 100/12.5 Kb all chan */
      public const Int16 ARU_RECV_RATE = 2;         /* AR_HIGH/AR_LOW for 100/12.5 Kb all chan */
      public const Int16 ARU_PARITY = 3;            /* Xmit parity, all channels AR_EVEN/AR_ODD*/
      public const Int16 ARU_INTERNAL_WRAP = 4;     /* Internal wrap all channels AR_ON/AR_OFF */
      public const Int16 ARU_EXTERNAL_WRAP = 5;     /* External wrap all channels AR_ON/AR_OFF */

      /* channel validation definitions in addition to set/get config items */
      public const Int16 ARU_GET_DATA = 284;
      public const Int16 ARU_PUT_DATA = 285;
      public const Int16 ARU_FILTER_LABEL = 286;

      /*---------------------------------------------------------------------------*
       * ARINC 573/717 specific value parameters for ar_et/get_573_config Items 
       *---------------------------------------------------------------------------*/
      public const Int16 ARU_573_RATE_SIZE_384_32 = 0;
      public const Int16 ARU_573_RATE_SIZE_768_64 = 1;
      public const Int16 ARU_573_RATE_SIZE_1536_128 = 2;
      public const Int16 ARU_573_RATE_SIZE_3072_256 = 3;
      public const Int16 ARU_573_RATE_SIZE_6144_512 = 4;
      public const Int16 ARU_573_RATE_SIZE_12288_1024 = 5;
      public const Int16 ARU_573_RATE_SIZE_24576_2048 = 6;
      public const Int16 ARU_573_RATE_SIZE_49152_4096 = 7;
      public const Int16 ARU_573_SPEED_384 = 384;
      public const Int16 ARU_573_SPEED_768 = 768;
      public const Int16 ARU_573_SPEED_1536 = 1536;
      public const Int16 ARU_573_SPEED_3072 = 3072;
      public const Int16 ARU_573_SPEED_6144 = 6144;
      public const Int16 ARU_573_SPEED_12288 = 12288;
      public const Int16 ARU_573_SPEED_24576 = 24576;
      public const Int16 DEFAULT_BUS_SPEED = 384;
      public const Int16 ARU_573_SUB_FRAME_64 = 64;
      public const Int16 ARU_573_SUB_FRAME_128 = 128;
      public const Int16 ARU_573_SUB_FRAME_256 = 256;
      public const Int16 ARU_573_SUB_FRAME_512 = 512;
      public const Int16 ARU_573_SUB_FRAME_1024 = 1024;
      public const Int16 ARU_573_SUB_FRAME_2048 = 2048;
      public const Int16 ARU_573_SUB_FRAME_4096 = 4096;
      public const Int16 ARU_573_SUB_FRAME_8192 = 8192;
      public const Int16 DEFAULT_FRAME_SIZE = 64;
      public const Int16 ARU_573_TX_SLEW_10PT0 = 0;
      public const Int16 ARU_573_TX_SLEW_1PT5 = 1;

      public const Int16 ARU_573_RX_ENABLE = 300;
      public const Int16 ARU_573_RX_AUTO_DETECT = 301;
      public const Int16 ARU_573_RX_BPRZ_SELECT = 302;
      public const Int16 ARU_573_RX_SUBFRAME_SIZE = 304;
      public const Int16 ARU_573_TX_SLEW_RATE = 305;
      public const Int16 ARU_573_SYNC_WORD1 = 307;
      public const Int16 ARU_573_SYNC_WORD2 = 308;
      public const Int16 ARU_573_SYNC_WORD3 = 309;
      public const Int16 ARU_573_SYNC_WORD4 = 310;
      public const Int16 ARU_573_SYNC_WORD12 = 311;
      public const Int16 ARU_573_SYNC_WORD34 = 312;
      public const Int16 ARU_573_TX_BPRZ_SELECT = 313;
      public const Int16 ARU_573_TX_HBP_SELECT = 314;


      /*------------------------------------------------------------------------*
       * General Function Constants used for various things
       *------------------------------------------------------------------------*/
      /* the following constants are used with the function ar_board_test() */
      public const Int16 INTERNAL_WRAP = 1;
      public const Int16 BAUD_100_TIMETAG_DEV = 18;
      public const Int16 BAUD_125_TIMETAG_DEV = 144;
      public const Int16 BAUD_11_TIMETAG_DEV = 150;

      /* the following constants are used with the function ar_set_transmitter_mode() */
      public const Int16 ARU_XMIT_573_HBP = 1;
      public const Int16 ARU_XMIT_573_BPRZ = 2;

      public const Int16 ARU_LABEL_ONLY = 0;
      public const Int16 ARU_LABEL_WITH_SDI = 1;

      public const Int16 ARU_CONCURRENCY_MODE = 1;
      public const UInt32 AR_CONC_NONE = 0;
      public const UInt32 AR_CONC_MULTIPROC = 1;
      public const UInt32 AR_CONC_MULTITHRD = 2;

      public const Int16 INTERNAL = 0;
      public const Int16 EXTERNAL = 1;
      public const Int16 TRANSMIT_CHANNEL = 0;
      public const Int16 RECEIVE_CHANNEL = 1;
      public const Int16 EXIT_KEY = 27;
      public const UInt32 PARITY_BIT = 0x80000000;
      public const UInt32 DATA_BITS = 0x7FFFFFFF;

      /* the following constants are used with the function ar_set_storage_mode()   */
      public const Int16 ARU_BUFFERED = 0;            /* Set receiver to BUFFERED mode   */
      public const Int16 ARU_DEDICATED = 1;           /* Set receiver to DEDICATED mode  */
      public const Int16 ARU_MERGED = 2;              /* Set receiver to MERGED mode     */

      /* Receive Channel Status bits used to indicate channel status in ar_get_rx_channel_status()  */
      public const Int16 AR_BUFFER_MSG_AVAILABLE = 1;
      public const Int16 AR_INVALID_MSG_DETECTED = 2;
      public const Int16 AR_BUFFER_OVERFLOW_DETECTED = 4;

      /* the following constants are used with the function ar_label_filter()  */
      public const Int16 ARU_ALL_LABELS = 0x1FF;         /* Enable/disable ALL label filtering     */
      public const Int16 ARU_FILTER_OFF = 0;             /* Filter off--pass specified label(s)    */
      public const Int16 ARU_FILTER_ON = 1;              /* Filter on--delete specified label(s)   */
      public const Int16 LABEL_FILTER_ARRAY_SIZE = 8;
      public const Int16 ARINC_LABEL_MASK = 0xFF;
      public const Int16 ARINC_SDI_MASK = 0x300;
      public const Int16 ARINC_SDI_SHIFT = 8;

      /* Time-tag format selection */
      public const Int16 AR_TIMETAG_EXT_IRIG_64BIT = 0;
      public const Int16 AR_TIMETAG_INT_USEC_64BIT = 1;
      public const Int16 AR_TIMETAG_HOST_USEC_64BIT = 2;
      public const Int16 AR_TIMETAG_INT_20USEC_32BIT = 3;
      public const Int16 AR_TIMETAG_INT_MSEC_32BIT = 4;
      public const Int16 AR_TIMETAG_EXT_IRIG_REF_64BIT = 5;
      public const Int16 AR_TIMER_X20_COMPAT_32BIT = 6;
      public const Int16 AR_TIMETAG_HOST_SEC_32BIT = 7;
      public const Int16 AR_TIMETAG_REF_IRIG_64BIT = 8;
      public const Int16 AR_LOG_EXT_IRIG_SAMPLE = 9;
      public const Int16 AR_TIMETAG_EXT_IRIG_RAW = 10;
      public const Int16 AR_TIMETAG_SYNC_1553_CH1 = 11;
      public const Int16 AR_TIMETAG_SYNC_1553_CH2 = 12;
      public const Int16 AR_TIMETAG_SYNC_1553_CH3 = 13;
      public const Int16 AR_TIMETAG_SYNC_1553_CH4 = 14;

      /* Time-tag string conversion format selection and array size */
      public const Int16 AR_TD_DATE = 0;
      public const Int16 AR_TD_IRIG = 1;

      /* BIT execution selection */
      public const Int16 AR_BIT_BASIC_STARTUP = 0;
      public const Int16 AR_BIT_FULL_STARTUP = 1;
      public const Int16 AR_BIT_PERIODIC = 2;
      public const Int16 AR_BIT_INT_LOOPBACK = 3;
      public const Int16 AR_BIT_EXT_LOOPBACK = 4;
      public const Int16 AR_BIT_PARTIAL_SRAM = 8;
      public const Int16 AR_BIT_FULL_SRAM = 9;
      public const Int16 AR_BIT_RX_LOOPBACK = 10;
      public const Int16 AR_BIT_SELECT_SRAM_MIN = 100;
      public const Int16 AR_BIT_SELECT_SRAM_MAX = 1123;

      /*---------------------------------------------------------------------------*
       * Message Scheduler API routine data structure for the definition and
       * parameter usage of CEI-830 periodic message scheduling data
       *---------------------------------------------------------------------------*/
      public const UInt32 ARU_SCHED_MSG_INFINITE = 0xFFFFFFFF;

      /*---------------------------------------------------------------------------*
       * Combo Board Shared Host Interface Memory Access Constants for use with
       * AR_GET_DEVICE_CONFIG.  When using these item values, the channel parameter
       * is used to index the 1553 channel number, with a valid range from 0 to 4.
       *---------------------------------------------------------------------------*/
      public const Int16 ARU_1553_CHANNEL_INITIALIZED = 10000;
      public const Int16 ARU_1553_CHANNEL_STATUS = 10001;
      public const Int16 ARU_1553_DISCRETE_USE = 10002;
      public const Int16 ARU_1553_TRIGGER_USE = 10003;
      public const Int16 ARU_1553_RT_ADDRESS = 10004;
      public const Int16 ARU_1553_OPERATIONAL_MODE = 10005;
      public const Int16 ARU_1553_TIME_TAG_MODE = 10006;
      public const Int16 ARU_1553_TIME_TAG_INIT = 10007;
      public const Int16 ARU_1553_TIME_TAG_DISPLAY = 10008;
      public const Int16 ARU_1553_TIME_PERIOD = 10009;
      public const Int16 ARU_1553_INITIAL_TIME_LOW = 10010;
      public const Int16 ARU_1553_INITIAL_TIME_HIGH = 10011;

      /*---------------------------------------------------------------------------*
       * CEI-x30 Hardware Configuration definitions
       *---------------------------------------------------------------------------*/
      public const UInt32 CEIDEV_ALT_CONFIG_717_SHIFT = 8;
      public const UInt32 CEIDEV_ALT_CONFIGURATION_717 = 256;
      public const UInt32 CEIDEV_NUM_CONFIGURATIONS = 21;
      public const UInt32 CEIDEV_CONFIG_CEI830 = 7;
      public const UInt32 CEIDEV_CONFIG_CEI430 = 8;
      public const UInt32 CEIDEV_CONFIG_AMCA30 = 9;
      public const UInt32 CEIDEV_CONFIG_CEI530 = 10;
      public const UInt32 CEIDEV_CONFIG_R830RX = 11;
      public const UInt32 CEIDEV_CONFIG_RAR_CPCI = 12;
      public const UInt32 CEIDEV_CONFIG_RAR_EC = 13;
      public const UInt32 CEIDEV_CONFIG_RAR_PCIE = 14;
      public const UInt32 CEIDEV_CONFIG_CEI430A = 15;
      public const UInt32 CEIDEV_CONFIG_RAR15 = 16;
      public const UInt32 CEIDEV_CONFIG_RAR15XT = 17;
      public const UInt32 CEIDEV_CONFIG_R830X820 = 18;
      public const UInt32 CEIDEV_CONFIG_RAR_XMC = 19;
      public const UInt32 CEIDEV_CONFIG_RCEI830A = 20;
      public const UInt32 CEIDEV_CONFIGURATION_MASK = 31;
      public const UInt32 CEIDEV_MAX_CHANNELS = 256;
      public const UInt32 CEIDEV_CHANNEL_MASK = 255;
      public const UInt32 CEIDEV_MAX_RX_CHAN = 32;
      public const UInt32 CEIDEV_MAX_TX_CHAN = 32;
      public const UInt32 CEIDEV_RAR15_XT_MAX_TX_CHAN = 8;

      /*---------------------------------------------------------------------------*
       * ARINC 573 Receive Message Data Mask Definitions
       *---------------------------------------------------------------------------*/
      public const UInt16 CEIDEV_573_SYNC_MASK = 0x8000;
      public const Int16 CEIDEV_573_SUBFRAME_MASK = 0x3000;
      public const Int16 CEIDEV_573_DATA_MASK = 0xFFF;
      public const Int16 CEIDEV_573_SYNCH_SHIFT = 16;
   }
}
