using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace ArincAPI
{
   namespace DataTypes
   {
      /*---------------------------------------------------------------------------*
       * Message Scheduler API routine data structure for the definition and
       * parameter usage of CEI-x30 periodic message scheduling data.
       * See the CEI-x30-SW User Manual, chapter "CEI-x30 Hardware Interface" for
       * a detailed explanation of the host interface scheduler table definition.
       *---------------------------------------------------------------------------*/
      [StructLayout(LayoutKind.Sequential)]
      public class AR_SCHEDULED_MSG_ENTRY_TYPE
      {
         public UInt32 messageIndex = 0;
         public UInt32 board = 0;
         public UInt32 channel = 0;
         public UInt32 rate = 0;
         public UInt32 start = 0;
         public UInt32 txCount = 0;
         public UInt32 data = 0;    
      };

      /*-----------------------------------------------------------------------------*
       * Time-tag structure defined for any API routine passing a 64-bit time-tag
       * structure parameter - routines named with an "_xt" suffix & ar_get/set_time.
       *-----------------------------------------------------------------------------*/
      [StructLayout(LayoutKind.Sequential)]
      public class AR_TIMETAG_TYPE 
      {
         public UInt64 timeTagFormat = 0;
         public UInt64 timeTag = 0;
         public UInt64 referenceTimeTag = 0;
      };
   }
}
