VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "CEI-x30 VB Example"
   ClientHeight    =   5610
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5085
   LinkTopic       =   "Form1"
   ScaleHeight     =   5610
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFilter 
      Caption         =   "Label Filter Toggle"
      Height          =   615
      Left            =   3840
      TabIndex        =   5
      Top             =   120
      Width           =   975
   End
   Begin VB.ListBox lstBoardNum 
      Height          =   450
      Left            =   240
      TabIndex        =   3
      Tag             =   "Board Number"
      Top             =   240
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   4545
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   4575
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "&Run"
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Top             =   360
      Width           =   855
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "Board Number"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   0
      Width           =   1335
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*===========================================================================*
' * FILE:                       C D E V _ V B . F R M
' *===========================================================================*
' *
' * COPYRIGHT (C) 2004-2016 BY
' *          ABACO SYSTEMS, INC., SANTA BARBARA, CALIFORNIA
' *          ALL RIGHTS RESERVED.
' *
' *          THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND
' *          COPIED ONLY IN ACCORDANCE WITH THE TERMS OF SUCH LICENSE AND WITH
' *          THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR ANY
' *          OTHER COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE
' *          AVAILABLE TO ANY OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF THE
' *          SOFTWARE IS HEREBY TRANSFERRED.
' *
' *          THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT
' *          NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY
' *          ABACO SYSTEMS, INC.
' *
' *===========================================================================*
' *
' * FUNCTION:    Example routine for communicating with the target board.
' *
' * DESCRIPTION:
' *
' *      IMPORTANT NOTE:  This routine assumes a 32-bit compiler (i.e. the
' *              datatype "int" is 32 bits in size, etc.)  It has not been
' *              tested with a 16-bit compiler.
' *
' *===========================================================================*/

Option Explicit
Option Base 0

Private Sub BoardNumber_Click()

End Sub

Private Sub cmdExit_Click()
  End
End Sub

Private Sub cmdFilter_Click()
    If filterEnable = 0 Then        'Toggle from "filter no labels" to "filter most labels"
        filterEnable = 1
    ElseIf filterEnable = 1 Then    'Toggle from "filter most labels" to "filter all labels"
        filterEnable = 2
    ElseIf filterEnable = 2 Then    'Toggle from "filter all labels" back to "filter no labels"
        filterEnable = 0
    End If
End Sub

Private Sub cmdRun_Click()

Dim nrx As Integer
Dim ntx As Integer

Dim status As Long
Dim nwords As Long

Dim arinc_word As Long
Dim timetag As Long
Dim strDat As String
Dim board As Integer


  ' first, clear the list box
  List1.Clear
  board = lstBoardNum.ListIndex
  
  '-----------------------------------------------------------------------
  ' This example defaults to Device 0 - Board 0
  ' open a session to the CEI-715 installed as device 0
  '-----------------------------------------------------------------------
  status = ar_loadslv(board, 0, 0, 0)
  If status <> ARS_NORMAL Then
      MsgBox ("ar_loadslv() returned: " & status)
      Exit Sub
  End If
  
  '-----------------------------------------------------------------------
  ' determine the number of receivers and transmitters installed
  '-----------------------------------------------------------------------
  nrx = ar_num_rchans(board)
  ntx = ar_num_xchans(board)
  
  strDat = "Board " & board & " Initialized"
  List1.AddItem strDat
  strDat = "Number of Receivers Detected: " & nrx
  List1.AddItem strDat
  strDat = "Number of Transmitters Detected: " & ntx
  List1.AddItem strDat

  '-----------------------------------------------------------------------
  ' enable channel 0 internal wrap and receive/transmit,
  ' use the default bus speed & parity settings
  '-----------------------------------------------------------------------

  If ar_set_device_config(board, 0, ARU_RECV_MODE, AR_WRAP_ON) <> ARS_NORMAL Then
       MsgBox ("ar_set_device_config() returned error:" & status)
       Exit Sub
  End If

  If ar_set_device_config(board, 0, ARU_TX_FIFO_ENABLE, AR_ON) <> ARS_NORMAL Then
       MsgBox ("ar_set_device_config() returned error:" & status)
       Exit Sub
  End If

  If ar_set_device_config(board, 0, ARU_RX_FIFO_ENABLE, AR_ON) <> ARS_NORMAL Then
       MsgBox ("ar_set_device_config() returned error:" & status)
       Exit Sub
  End If

  '-----------------------------------------------------------------------
  '  Enable Label Filtering on channel 0 as selected by the
  '  Label Filter Toggle Button
  '  DEFAULT:    No Filtering
  '  1st Click:  Filter all labels with the exception of 0x70 and 0x79
  '  2nd Click:  Filter all labels
  '  3rd Click:  No Filtering, back to DEFAULT setting
  '  repeat 1st Click, 2nd Click, and so on...
  '-----------------------------------------------------------------------
  strDat = " "
  List1.AddItem strDat
  If filterEnable = 1 Then
      status = ar_label_filter(board, 0, ARU_ALL_LABELS, ARU_FILTER_ON)
      status = ar_label_filter(board, 0, &H70, ARU_FILTER_OFF)
      status = ar_label_filter(board, 0, &H79, ARU_FILTER_OFF)
      strDat = "Channel 0 Label Filtering Disabled for labels h70 and h79 only"
      List1.AddItem strDat
  ElseIf filterEnable = 2 Then
      status = ar_label_filter(board, 0, ARU_ALL_LABELS, ARU_FILTER_ON)
      strDat = "Channel 0 Label Filtering Enabled for ALL labels"
      List1.AddItem strDat
  ElseIf filterEnable = 0 Then
      status = ar_label_filter(board, 0, ARU_ALL_LABELS, ARU_FILTER_OFF)
      strDat = "Channel 0 Label Filtering Disabled"
      List1.AddItem strDat
  End If
  strDat = " "
  List1.AddItem strDat
  
  '-----------------------------------------------------------------------
  '  Enable data processing.
  '-----------------------------------------------------------------------
  status = ar_go(board)
  
  '-----------------------------------------------------------------------
  '  Transmit 10 words on channel 0
  '-----------------------------------------------------------------------
  nwords = 0
  While (nwords < 10)
'       status = ar_put_429_message(board, 0, &H12345670 + nwords)
       status = ar_define_msg(board, 0, 100, 0, &H12345670 + nwords)
       nwords = nwords + 1
  Wend
  
  '-----------------------------------------------------------------------
  '  Read all of the data that has been received so far on receiver 0.
  '-----------------------------------------------------------------------
  nwords = 0
  status = ARS_GOTDATA
  While ((status = ARS_GOTDATA) And (nwords < 10))
       status = ar_getnextt(board, 0, arinc_word, timetag)
       If status = ARS_GOTDATA Then
           strDat = "Channel 0 Received: " & Hex(arinc_word)
           List1.AddItem strDat
           nwords = nwords + 1
       End If
  Wend

  '-----------------------------------------------------------------------*
  '  Stop the board processing data and exit.
  '-----------------------------------------------------------------------*/
  strDat = "Test Complete, Number of Words Received: " & nwords
  List1.AddItem strDat
  ar_stop board
  ar_close board

End Sub




Private Sub Form_Load()
Dim j As Integer
    
   For j = 0 To 9
      lstBoardNum.AddItem j
   Next j
    
   lstBoardNum.ListIndex = 0
   filterEnable = 0
    
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
  'close board
  ar_close board
End Sub

